﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections;
using infra=Infragistics.Silverlight.Controls;
using System.Text;
using System.Xml;
using System.Windows.Markup;
using System.Xml.Linq;
using System.IO;
using System.Windows.Data; 

namespace SilverlightTable
{
    public partial class Dictionary : UserControl
    {
        public Dictionary()
        {
            InitializeComponent();
        }

        String str;

        public IEnumerable<IDictionary> GenerateData()
        {

            XDocument xdoc1 = XDocument.Load("xmlString.xml");

            //Load Columns into an array
            string[] strCols = new string[xdoc1.Descendants("COLUMN").Count()];
            int colcounter = 0;
            foreach (XElement colgrid in xdoc1.Descendants("COLUMN"))
            {
                strCols[colcounter] = colgrid.Descendants("header_dscp").First().Value;
                colcounter++;
            }

            colcounter = 0;
            foreach (XElement rowgrid in xdoc1.Descendants("ROW"))
            {
                var dict = new Dictionary<string, object>();
                foreach (XElement cellgrid in rowgrid.Descendants("CELL"))
                {
                    dict[strCols[colcounter].Replace(" " , "")] = cellgrid.Descendants("value").First().Value;
                    if (cellgrid.Descendants("href").Count() > 0)
                    {
                        dict["cell" + colcounter.ToString() + "hreftarget"] = cellgrid.Descendants("href").Attributes("target").First().Value;
                        XElement hrefelm = cellgrid.Descendants("href").First();
                        //dict["cell" + colcounter.ToString() + "hreftitle"] = cellgrid.Descendants("href").items[0];
                        dict["cell" + colcounter.ToString() + "hrefurl"] = hrefelm.Value;
                    }
                    colcounter++;
                }
                colcounter = 0;
                yield return dict;

            }

        }

        private void UserControl_Loaded(object sender, RoutedEventArgs e)
        {


            XDocument xdoc1 = XDocument.Load("xmlString.xml");
            List<XElement> lst = xdoc1.Descendants("CELL").ToList();

            string headertext = "";

            int colcount = 0;
            int innercount = 0;

            foreach (XElement columngrid in xdoc1.Descendants("COLUMN"))
            {

                infra.TemplateColumn tcol = new infra.TemplateColumn();
                headertext = columngrid.Descendants("header_dscp").First().Value;
                tcol.Key = headertext.Replace(" ","");

                StringBuilder HeaderTemplate = new StringBuilder();
                HeaderTemplate.Append("<DataTemplate");
                HeaderTemplate.Append(" xmlns=\"http://schemas.microsoft.com/winfx/2006/xaml/presentation\" ");
                HeaderTemplate.Append(" xmlns:x=\"http://schemas.microsoft.com/winfx/2006/xaml\"");
                HeaderTemplate.Append(" xmlns:igGrid=\"clr-namespace:Infragistics.Silverlight.Controls;assembly=Infragistics.Silverlight.XamWebGrid.v9.1\"");
                HeaderTemplate.Append(" xmlns:controls=\"clr-namespace:System.Windows.Controls;assembly=System.Windows.Controls\"");
                HeaderTemplate.Append(" xmlns:local=\"clr-namespace:SilverlightTable;assembly=SilverlightTable\"");
                HeaderTemplate.Append(">");
                HeaderTemplate.Append("<TextBlock TextWrapping=\"Wrap\" Text=\"" + headertext + "\"/>");
                HeaderTemplate.Append("</DataTemplate>");

                tcol.HeaderTemplate = (DataTemplate)XamlReader.Load(HeaderTemplate.ToString());

                StringBuilder ItemTemplate = new StringBuilder();

                ItemTemplate.Append("<DataTemplate");
                ItemTemplate.Append(" xmlns=\"http://schemas.microsoft.com/winfx/2006/xaml/presentation\" ");
                ItemTemplate.Append(" xmlns:x=\"http://schemas.microsoft.com/winfx/2006/xaml\"");
                ItemTemplate.Append(" xmlns:igGrid=\"clr-namespace:Infragistics.Silverlight.Controls;assembly=Infragistics.Silverlight.XamWebGrid.v9.1\"");
                ItemTemplate.Append(" xmlns:controls=\"clr-namespace:System.Windows.Controls;assembly=System.Windows.Controls\"");
                ItemTemplate.Append(" xmlns:local=\"clr-namespace:SilverlightTable;assembly=SilverlightTable\"");
                ItemTemplate.Append(">");
                ItemTemplate.Append("<Grid>");
                ItemTemplate.Append("<Grid.Resources>");
                ItemTemplate.Append("<local:DoubleToBrushConverter x:Key='converter'/>");
                ItemTemplate.Append("<local:ElementBinding x:Key='someObject' Value='66'/>");
                ItemTemplate.Append("<local:RowIndexConverter x:Key='RowIndexConverter'/>");
                ItemTemplate.Append("</Grid.Resources>");

                //Check if HREF parameter
                Boolean isHREF = false;
                innercount = 0;
                foreach (XElement rowgrid in xdoc1.Descendants("ROW"))
                {
                    foreach (XElement cellgrid in rowgrid.Descendants("CELL"))
                    {
                        if (colcount == innercount)
                        {
                            if (cellgrid.Descendants("href").Count() > 0)
                            {
                                isHREF=true;
                                break;
                            }
                        }
                        innercount++;
                    }
                    break;
                }

                

                if (isHREF)
                {

                    ItemTemplate.Append("<HyperlinkButton");
                    ItemTemplate.Append(" NavigateUri=\"{Binding " + "cell" + colcount.ToString() + "hrefurl" + "}\"");
                    ItemTemplate.Append(" TargetName=\"{Binding " + "cell" + colcount.ToString() + "hreftarget" + "}\" ");
                    ItemTemplate.Append(" >");
                    ItemTemplate.Append("<TextBlock TextWrapping=\"Wrap\" Text=\"{Binding " + headertext + "}\"/>");
                    ItemTemplate.Append("</HyperlinkButton>");
                }
                else
                {
                    ItemTemplate.Append("<TextBlock TextWrapping=\"Wrap\" Text=\"{Binding " + headertext.Replace(" ", "") + "}\"/>");
                }
                
                //ItemTemplate.Append("<HyperlinkButton Content=\"{Binding " + strName + "}\" NavigateUri=\"http://www.yahoo.com\"/>");
                ItemTemplate.Append("</Grid>");
                ItemTemplate.Append("</DataTemplate>");

                tcol.ItemTemplate = (DataTemplate)XamlReader.Load(ItemTemplate.ToString());

                StringBuilder GroupByTemplate = new StringBuilder();

                GroupByTemplate.Append("<DataTemplate");
                GroupByTemplate.Append(" xmlns=\"http://schemas.microsoft.com/winfx/2006/xaml/presentation\" ");
                GroupByTemplate.Append(" xmlns:x=\"http://schemas.microsoft.com/winfx/2006/xaml\"");
                GroupByTemplate.Append(" xmlns:igGrid=\"clr-namespace:Infragistics.Silverlight.Controls;assembly=Infragistics.Silverlight.XamWebGrid.v9.1\"");
                GroupByTemplate.Append(" xmlns:controls=\"clr-namespace:System.Windows.Controls;assembly=System.Windows.Controls\"");
                GroupByTemplate.Append(" xmlns:local=\"clr-namespace:SilverlightTable;assembly=SilverlightTable\"");
                GroupByTemplate.Append(">");
                GroupByTemplate.Append("<StackPanel Orientation=\"Horizontal\">");
                GroupByTemplate.Append("<TextBlock Text=\"{Binding Value}\"/>");
                GroupByTemplate.Append("<TextBlock Text=\"( \"/>");
                GroupByTemplate.Append("<TextBlock Text=\"{Binding Count}\"/>");
                GroupByTemplate.Append("<TextBlock Text=\" ) \"/>");
                GroupByTemplate.Append("</StackPanel>");
                GroupByTemplate.Append("</DataTemplate>");

                tcol.GroupByItemTemplate = (DataTemplate)XamlReader.Load(GroupByTemplate.ToString());

                dataGrid.Columns.Add(tcol);

                colcount++;

            }

            dataGrid.ItemsSource = GenerateData().ToDataSource();
        }
    }
}